require 'puppet/resource_api'

Puppet::ResourceApi.register_type(
  name: 'dsc_keyexchangealgorithm',
  dscmeta_resource_friendly_name: 'KeyExchangeAlgorithm',
  dscmeta_resource_name: 'MSFT_KeyExchangeAlgorithm',
  dscmeta_resource_implementation: 'MOF',
  dscmeta_module_name: 'SChannelDsc',
  dscmeta_module_version: '1.2.2',
  docs: 'The DSC KeyExchangeAlgorithm resource type.
         Automatically generated from version 1.2.2',
  features: ['simple_get_filter', 'canonicalize', 'custom_insync'],
  attributes: {
    name: {
      type:      'String',
      desc:      'Description of the purpose for this resource declaration.',
      behaviour: :namevar,
    },
    validation_mode: {
      type:      'Enum[property, resource]',
      desc:      'Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode (resource).',
      behaviour: :parameter,
      default:   'property',
    },
    dsc_psdscrunascredential: {
      type: 'Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]',
      desc: ' ',
      behaviour: :parameter,
      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'PSCredential',
      mof_is_embedded: true,
    },
    dsc_keyexchangealgorithm: {
      type: "Enum['Diffie-Hellman', 'ECDH', 'PKCS']",
      desc: ' ',
      behaviour: :namevar,
      mandatory_for_get: true,
      mandatory_for_set: true,
      mof_type: 'String',
      mof_is_embedded: false,
    },
    dsc_state: {
      type: "Optional[Enum['Enabled', 'Disabled', 'Default']]",
      desc: ' ',

      mandatory_for_get: false,
      mandatory_for_set: false,
      mof_type: 'String',
      mof_is_embedded: false,
    },
  },
)
